/*  @file 
     Define KeyIds for BigDFT input paramater structure.
    @author
     Copyright (C) 2011-2013 BigDFT group (DC)
     This file is distributed under the terms of the
     GNU General Public License, see ~/COPYING file
     or http://www.gnu.org/copyleft/gpl.txt .
     For the list of contributors, see ~/AUTHORS 
*/


typedef enum {
  INPUTS_DFT_VARIABLES,
  INPUTS_HGRIDS,
  INPUTS_RMULT,
  INPUTS_IXC,
  INPUTS_NCHARGE,
  INPUTS_ELECFIELD,
  INPUTS_NSPIN,
  INPUTS_MPOL,
  INPUTS_GNRM_CV,
  INPUTS_ITERMAX,
  INPUTS_NREPMAX,
  INPUTS_NCONG,
  INPUTS_IDSX,
  INPUTS_DISPERSION,
  INPUTS_INPUTPSIID,
  INPUTS_OUTPUT_WF,
  INPUTS_OUTPUT_DENSPOT,
  INPUTS_RBUF,
  INPUTS_NCONGT,
  INPUTS_NORBV,
  INPUTS_NVIRT,
  INPUTS_NPLOT,
  INPUTS_DISABLE_SYM,
  INPUTS_KPT_VARIABLES,
  INPUTS_KPT_METHOD,
  INPUTS_KPTRLEN,
  INPUTS_NGKPT,
  INPUTS_SHIFTK,
  INPUTS_KPT,
  INPUTS_WKPT,
  INPUTS_BANDS,
  INPUTS_ISEG,
  INPUTS_KPTV,
  INPUTS_NGRANULARITY,
  INPUTS_BAND_STRUCTURE_FILENAME,
  INPUTS_GEOPT_VARIABLES,
  INPUTS_GEOPT_METHOD,
  INPUTS_NCOUNT_CLUSTER_X,
  INPUTS_FRAC_FLUCT,
  INPUTS_FORCEMAX,
  INPUTS_RANDDIS,
  INPUTS_IONMOV,
  INPUTS_DTION,
  INPUTS_MDITEMP,
  INPUTS_MDFTEMP,
  INPUTS_NOSEINERT,
  INPUTS_FRICTION,
  INPUTS_MDWALL,
  INPUTS_NNOS,
  INPUTS_QMASS,
  INPUTS_BMASS,
  INPUTS_VMASS,
  INPUTS_BETAX,
  INPUTS_HISTORY,
  INPUTS_DTINIT,
  INPUTS_SOCKINET,
  INPUTS_SOCKHOST,
  INPUTS_SOCKPORT,
  INPUTS_DTMAX,
  INPUTS_MIX_VARIABLES,
  INPUTS_ISCF,
  INPUTS_ITRPMAX,
  INPUTS_RPNRM_CV,
  INPUTS_NORBSEMPTY,
  INPUTS_TEL,
  INPUTS_OCCOPT,
  INPUTS_ALPHAMIX,
  INPUTS_ALPHADIIS,
  INPUTS_SIC_VARIABLES,
  INPUTS_SIC_APPROACH,
  INPUTS_SIC_ALPHA,
  INPUTS_SIC_FREF,
  INPUTS_TDDFT_VARIABLES,
  INPUTS_TDDFT_APPROACH,
  INPUTS_PERF_VARIABLES,
  INPUTS_DEBUG,
  INPUTS_FFTCACHE,
  INPUTS_ACCEL,
  INPUTS_OCL_PLATFORM,
  INPUTS_OCL_DEVICES,
  INPUTS_BLAS,
  INPUTS_PROJRAD,
  INPUTS_EXCTXPAR,
  INPUTS_IG_DIAG,
  INPUTS_IG_NORBP,
  INPUTS_IG_BLOCKS,
  INPUTS_IG_TOL,
  INPUTS_METHORTHO,
  INPUTS_RHO_COMMUN,
  INPUTS_PSOLVER_GROUPSIZE,
  INPUTS_PSOLVER_ACCEL,
  INPUTS_UNBLOCK_COMMS,
  INPUTS_LINEAR,
  INPUTS_TOLSYM,
  INPUTS_SIGNALING,
  INPUTS_SIGNALTIMEOUT,
  INPUTS_DOMAIN,
  INPUTS_INGUESS_GEOPT,
  INPUTS_STORE_INDEX,
  INPUTS_VERBOSITY,
  INPUTS_OUTDIR,
  INPUTS_PSP_ONFLY,
  INPUTS_MULTIPOLE_PRESERVING,
  INPUTS_MP_ISF,
  INPUTS_PDSYEV_BLOCKSIZE,
  INPUTS_PDGEMM_BLOCKSIZE,
  INPUTS_MAXPROC_PDSYEV,
  INPUTS_MAXPROC_PDGEMM,
  INPUTS_EF_INTERPOL_DET,
  INPUTS_EF_INTERPOL_CHARGEDIFF,
  INPUTS_MIXING_AFTER_INPUTGUESS,
  INPUTS_ITERATIVE_ORTHOGONALIZATION
} BigDFT_InputsKeyIds;
