!> @file
!!   Filters for finite difference first derivative of a one dimensional function (order 16)
!! @author
!!    Copyright (C) 2014 BigDFT group 
!!    This file is distributed under the terms of the
!!    GNU General Public License, see ~/COPYING file
!!    or http://www.gnu.org/copyleft/gpl.txt .
!!    For the list of contributors, see ~/AUTHORS 


  ! Setting of 'nord' order accurate first derivative coefficient from 'Matematica'.
  !Only nord=2,4,6,8,16

   ! Coefficients from Matematica program.
select case(nord)
case(2)

!In[292]:= f[x_]:=Evaluate[InterpolatingPolynomial[{{-1,ym1},{0,y0},{1,yp1}},x]]
!In[293]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->0}]]]]
     c2D(-m:m,0) = (/&
     1.d0,-2.d0,1.d0&
     /)

!In[294]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-1}]]]]
     c2D(-m:m,-1) = (/&
     1.d0,-2.d0,1.d0&
     /)
!In[295]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->1}]]]]
     c2D(-m:m,1) = (/&
     1.d0,-2.d0,1.d0&
     /)

   case(4)

!In[296]:= f[x_]:=Evaluate[InterpolatingPolynomial[{{-2,ym2},{-1,ym1},{0,y0},{1,yp1},{2,yp2}},x]]
!In[297]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->0}]]]]


     c2D(-m:m,0) = (/&
     -1.d0/12.d0,4.d0/3.d0,-5.d0/2.d0,4.d0/3.d0,-1.d0/12.d0&
     /)
!In[298]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-1}]]]]
     c2D(-m:m,-1) = (/&
     11.d0/12.d0,-5.d0/3.d0,1.d0/2.d0,1.d0/3.d0,-1.d0/12.d0&
     /)
!In[299]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-2}]]]]
     c2D(-m:m,-2) = (/&
     35.d0/12.0,-26.d0/3.d0,19.d0/2.d0,-14.d0/3.d0,11.d0/12.d0&
     /)
!In[300]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->1}]]]]
     c2D(-m:m,1) = (/&
     -1.d0/12.d0,1.d0/3.d0,1.d0/2.d0,-5.d0/3.d0,11.d0/12.d0&
     /)
!In[301]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->2}]]]]
     c2D(-m:m,2) = (/&
     11.d0/12.d0,-14.d0/3.d0,19.d0/2.d0,-26.d0/3.d0,35.d0/12.d0&
     /)

!In[302]:= f[x_]:=Evaluate[InterpolatingPolynomial[{{-3,ym3},{-2,ym2},{-1,ym1},{0,y0},{1,yp1},{2,yp2},{3,yp3}},x]]
!In[303]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->0}]]]]

   case(6)

     c2D(-m:m,0) = (/&
     1.d0/90.d0,-3.d0/20.d0,3.d0/2.d0,-49.d0/18.d0,3.d0/2.d0,-3.d0/20.d0,1.d0/90.d0&
     /)
!In[304]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-1}]]]]
     c2D(-m:m,-1) = (/&
     -13.d0/180.d0,19.d0/15.d0,-7.d0/3.d0,10.d0/9.d0,1.d0/12.d0,-1.d0/15.d0,1.d0/90.d0&
     /)
!In[305]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->1}]]]]
     c2D(-m:m,1) = (/&
     1.d0/90.d0,-1.d0/15.d0,1.d0/12.d0,10.d0/9.d0,-7.d0/3.d0,19.d0/15.d0,-13.d0/180.d0&
     /)
!In[306]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-2}]]]]
     c2D(-m:m,-2) = (/&
     137.d0/180.d0,-49.d0/60.d0,-17.d0/12.d0,47.d0/18.d0,-19.d0/12.d0,31.d0/60.d0,-13.d0/180.d0&
     /)
!In[307]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+2}]]]]
     c2D(-m:m,2) = (/&
     -13.d0/180.d0,31.d0/60.d0,-19.d0/12.d0,47.d0/18.d0,-17.d0/12.d0,-49.d0/60.d0,137.d0/180.d0&
     /)
!In[308]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-3}]]]]
     c2D(-m:m,-3) = (/&
     203.d0/45.d0,-87.d0/5.d0,117.d0/4.d0,-254.d0/9.d0,33.d0/2.d0,-27.d0/5.d0,137.d0/180.d0&
     /)
!In[309]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+3}]]]]
     c2D(-m:m,3) = (/&
     137.d0/180.d0,-27.d0/5.d0,33.d0/2.d0,-254.d0/9.d0,117.d0/4.d0,-87.d0/5.d0,203.d0/45.d0&
     /)
!In[310]:= f[x_]:=Evaluate[InterpolatingPolynomial[{{-4,ym4},{-3,ym3},{-2,ym2},{-1,ym1},{0,y0},{1,yp1},{2,yp2},{3,yp3},{4,yp4}},x]]
!In[311]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->0}]]]]

   case(8)

     c2D(-m:m,0) = (/&
     -1.d0/560.d0,8.d0/315.d0,-1.d0/5.d0,8.d0/5.d0,-205.d0/72.d0,8.d0/5.d0,-1.d0/5.d0,8.d0/315.d0,-1.d0/560.d0&
     /)
!In[312]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-1}]]]]
     c2D(-m:m,-1) = (/&
     47.d0/5040.d0,-19.d0/140.d0,29.d0/20.d0,-118.d0/45.d0,11.d0/8.d0,-1.d0/20.d0,-7.d0/180.d0,1.d0/70.d0,-1.d0/560.d0&
     /)
!In[313]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->1}]]]]
     c2D(-m:m,1) = (/&
     -1.d0/560.d0,1.d0/70.d0,-7.d0/180.d0,-1.d0/20.d0,11.d0/8.d0,-118.d0/45.d0,29.d0/20.d0,-19.d0/140.d0,47.d0/5040.d0&
     /)
!In[314]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-2}]]]]
     c2D(-m:m,-2) = (/&
     -29.d0/560.d0,39.d0/35.d0,-331.d0/180.d0,1.d0/5.d0,9.d0/8.d0,-37.d0/45.d0,7.d0/20.d0,-3.d0/35.d0,47.d0/5040.d0&
     /)
!In[315]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+2}]]]]
     c2D(-m:m,2) = (/&
      47.d0/5040.d0,-3.d0/35.d0,7.d0/20.d0,-37.d0/45.d0,9.d0/8.d0,1.d0/5.d0,-331.d0/180.d0,39.d0/35.d0,-29.d0/560.d0&
     /)
!In[316]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-3}]]]]
     c2D(-m:m,-3) = (/&
     363.d0/560.d0,8.d0/315.d0,-83.d0/20.d0,153.d0/20.d0,-529.d0/72.d0,47.d0/10.d0,-39.d0/20.d0,& 
     599.d0/1260.d0,-29.d0/560.d0&
     /)
!In[317]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+3}]]]]
     c2D(-m:m,3) = (/&
     -29.d0/560.d0,599.d0/1260.d0,-39.d0/20.d0,47.d0/10.d0,-529.d0/72.d0,153.d0/20.d0,-83.d0/20.d0,&
     8.d0/315.d0,363.d0/560.d0&
     /)
!In[318]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-4}]]]]
     c2D(-m:m,-4) = (/&
     29531.d0/5040.d0,-962.d0/35.d0,621.d0/10.d0,-4006.d0/45.d0,691.d0/8.d0,-282.d0/5.d0,2143.d0/90.d0,& 
     -206.d0/35.d0,363.d0/560.d0&
     /)
!In[319]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+4}]]]]
     c2D(-m:m,4) = (/&
     363.d0/560.d0,-206.d0/35.d0,2143.d0/90.d0,-282.d0/5.d0,691.d0/8.d0,-4006.d0/45.d0,621.d0/10.d0,-962.d0/35.d0,& 
     29531.d0/5040.d0&
     /)

   case(10)

   case(12)

   case(14)

   case(16)

!In[75]:= f[x_]:=Evaluate[InterpolatingPolynomial[{{-8,ym8},{-7,ym7},{-6,ym6},{-5,ym5},{-4,ym4},{-3,ym3},{-2,ym2},{-1,ym1},{0,y0},{1,yp1},{2,yp2},{3,yp3},{4,yp4},{5,yp5},{6,yp6},{7,yp7},{8,yp8}},x]]
!In[76]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->0}]]]]
     c2D(-m:m,0) = (/&
     -1.d0/411840.d0,16.d0/315315.d0,-2.d0/3861.d0,112.d0/32175.d0,-7.d0/396.d0,112.d0/1485.d0,-14.d0/45.d0,&
     16.d0/9.d0,-1077749.d0/352800.d0,16.d0/9.d0,-14.d0/45.d0,112.d0/1485.d0,-7.d0/396.d0,&
     112.d0/32175.d0,-2.d0/3861.d0,16.d0/315315.d0,-1.d0/411840.d0&
     /)
!In[77]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-1}]]]]
     c2D(-m:m,-1) = (/&
     191.d0/20180160.d0,-29.d0/154440.d0,157.d0/85800.d0,-245.d0/20592.d0,&
     287.d0/4752.d0,-371.d0/1320.d0,623.d0/360.d0,-29359.d0/9800.d0,&
     55.d0/32.d0,-19.d0/72.d0,49.d0/1080.d0,-7.d0/2640.d0,-91.d0/39600.d0,&
     35.d0/30888.d0,-47.d0/168168.d0,1.d0/25740.d0,-1.d0/411840.d0&
     /)
!In[78]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->1}]]]]
     c2D(-m:m,1) = (/&
     -1.d0/411840.d0,1.d0/25740.d0,-47.d0/168168.d0,35.d0/30888.d0,-91.d0/39600.d0,-7.d0/2640.d0,49.d0/1080.d0,-19.d0/72.d0,&
     55.d0/32.d0,-29359.d0/9800.d0,623.d0/360.d0,-371.d0/1320.d0,&
     287.d0/4752.d0,-245.d0/20592.d0,157.d0/85800.d0,-29.d0/154440.d0,191.d0/20180160.d0&
     /)
!In[79]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-2}]]]]
!Out[79]//FortranForm=
     c2D(-m:m,-2) = (/&
      -1627.d0/60540480.d0,1711.d0/3153150.d0,-167.d0/30576.d0,2047.d0/54054.d0,&
      -2467.d0/11088.d0,3727.d0/2310.d0,-8857.d0/3150.d0,1313.d0/882.d0,&
      -53.d0/1568.d0,-367.d0/2646.d0,577.d0/5040.d0,-703.d0/11550.d0,787.d0/33264.d0,&
      -11.d0/1638.d0,223.d0/168168.d0,-103.d0/630630.d0,191.d0/20180160.d0&
      /)
!In[80]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+2}]]]]
!Out[80]//FortranForm=
     c2D(-m:m,2) = (/&
     191.d0/20180160.d0,-103.d0/630630.d0,223.d0/168168.d0,-11.d0/1638.d0,787.d0/33264.d0,&
     -703.d0/11550.d0,577.d0/5040.d0,-367.d0/2646.d0,-53.d0/1568.d0,&
     1313.d0/882.d0,-8857.d0/3150.d0,3727.d0/2310.d0,-2467.d0/11088.d0,2047.d0/54054.d0,&
     -167.d0/30576.d0,1711.d0/3153150.d0,-1627.d0/60540480.d0&
     /)
!In[81]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-3}]]]]
!Out[81]//FortranForm=
     c2D(-m:m,-3) = (/&
     1997.d0/23284800.d0,-27347.d0/15135120.d0,29657.d0/1513512.d0,-34277.d0/216216.d0,&
     48137.d0/33264.d0,-1030829.d0/415800.d0,7303.d0/7560.d0,6557.d0/10584.d0,-11177.d0/14112.d0,&
     13487.d0/21168.d0,-14873.d0/37800.d0,15797.d0/83160.d0,-2351.d0/33264.d0,&
     163.d0/8316.d0,-5779.d0/1513512.d0,3529.d0/7567560.d0,-1627.d0/60540480.d0&
     /)
!In[82]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+3}]]]]
!Out[82]//FortranForm=
     c2D(-m:m,3) = (/&
     -1627.d0/60540480.d0,3529.d0/7567560.d0,-5779.d0/1513512.d0,163.d0/8316.d0,&
     -2351.d0/33264.d0,15797.d0/83160.d0,-14873.d0/37800.d0,13487.d0/21168.d0,&
     -11177.d0/14112.d0,6557.d0/10584.d0,7303.d0/7560.d0,-1030829.d0/415800.d0,&
     48137.d0/33264.d0,-34277.d0/216216.d0,29657.d0/1513512.d0,-27347.d0/15135120.d0,1997.d0/23284800.d0&
     /)
!In[83]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-4}]]]]
!Out[83]//FortranForm=
     c2D(-m:m,-4) = (/&
     -35201.d0/100900800.d0,37511.d0/4729725.d0,-42131.d0/420420.d0,4307.d0/3465.d0,&
     -540107.d0/277200.d0,-551.d0/5775.d0,14411.d0/6300.d0,-19031.d0/6615.d0,&
     21341.d0/7840.d0,-22727.d0/11025.d0,23651.d0/18900.d0,-3473.d0/5775.d0,12403.d0/55440.d0,&
     -311.d0/5005.d0,25499.d0/2102100.d0,-2341.d0/1576575.d0,1997.d0/23284800.d0&
     /)
!In[84]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+4}]]]]
!Out[84]//FortranForm=
     c2D(-m:m,4) = (/&
     1997.d0/23284800.d0,-2341.d0/1576575.d0,25499.d0/2102100.d0,-311.d0/5005.d0,&
     12403.d0/55440.d0,-3473.d0/5775.d0,23651.d0/18900.d0,-22727.d0/11025.d0,&
     21341.d0/7840.d0,-19031.d0/6615.d0,14411.d0/6300.d0,-551.d0/5775.d0,&
     -540107.d0/277200.d0,4307.d0/3465.d0,-42131.d0/420420.d0,37511.d0/4729725.d0,-35201.d0/100900800.d0&
     /)
!In[85]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-5}]]]]
!Out[85]//FortranForm=
     c2D(-m:m,-5) = (/&
     605453.d0/302702400.d0,-665513.d0/12612600.d0,845693.d0/840840.d0,-671551.d0/600600.d0,&
     -124973.d0/55440.d0,305153.d0/46200.d0,-365213.d0/37800.d0,395243.d0/35280.d0,&
     -413261.d0/39200.d0,425273.d0/52920.d0,-61979.d0/12600.d0,13759.d0/5775.d0,-49477.d0/55440.d0,&
     449297.d0/1801800.d0,-41143.d0/840840.d0,455303.d0/75675600.d0,-35201.d0/100900800.d0&
     /)
!In[86]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+5}]]]]
!Out[86]//FortranForm=
    c2D(-m:m,5) = (/&
    -35201.d0/100900800.d0,455303.d0/75675600.d0,-41143.d0/840840.d0,449297.d0/1801800.d0,&
    -49477.d0/55440.d0,13759.d0/5775.d0,-61979.d0/12600.d0,425273.d0/52920.d0,&
    -413261.d0/39200.d0,395243.d0/35280.d0,-365213.d0/37800.d0,305153.d0/46200.d0,-124973.d0/55440.d0,&
    -671551.d0/600600.d0,845693.d0/840840.d0,-665513.d0/12612600.d0,605453.d0/302702400.d0&
    /)
!In[87]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-6}]]]]
!Out[87]//FortranForm=
    c2D(-m:m,-6) = (/&
    -811373.d0/43243200.d0,991553.d0/1351350.d0,1144474.d0/4729725.d0,-270833.d0/38610.d0,&
    451013.d0/23760.d0,-511073.d0/14850.d0,541103.d0/10800.d0,-559121.d0/9450.d0,&
    571133.d0/10080.d0,-579713.d0/13230.d0,146537.d0/5400.d0,-197051.d0/14850.d0,595157.d0/118800.d0,&
    -54403.d0/38610.d0,601163.d0/2162160.d0,-46421.d0/1351350.d0,605453.d0/302702400.d0&
    /)
!In[88]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+6}]]]]
!Out[88]//FortranForm=
    c2D(-m:m,6) = (/&
    605453.d0/302702400.d0,-46421.d0/1351350.d0,601163.d0/2162160.d0,-54403.d0/38610.d0,&
    595157.d0/118800.d0,-197051.d0/14850.d0,146537.d0/5400.d0,-579713.d0/13230.d0,&
    571133.d0/10080.d0,-559121.d0/9450.d0,541103.d0/10800.d0,-511073.d0/14850.d0,451013.d0/23760.d0,&
    -270833.d0/38610.d0,1144474.d0/4729725.d0,991553.d0/1351350.d0,-811373.d0/43243200.d0&
    /)
!In[89]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-7}]]]]
!Out[89]//FortranForm=
    c2D(-m:m,-7) = (/&
    1195757.d0/2882880.d0,35236393.d0/12612600.d0,-475037.d0/24024.d0,655217.d0/10296.d0,&
    -715277.d0/4752.d0,745307.d0/2640.d0,-30533.d0/72.d0,775337.d0/1512.d0,&
    -783917.d0/1568.d0,49397.d0/126.d0,-88373.d0/360.d0,799361.d0/6600.d0,-72967.d0/1584.d0,&
    805367.d0/61776.d0,-62129.d0/24024.d0,809657.d0/2522520.d0,-811373.d0/43243200.d0&
    /)
!In[90]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+7}]]]]
!Out[90]//FortranForm=
    c2D(-m:m,7) = (/&
    -811373.d0/43243200.d0,809657.d0/2522520.d0,-62129.d0/24024.d0,805367.d0/61776.d0,&
    -72967.d0/1584.d0,799361.d0/6600.d0,-88373.d0/360.d0,49397.d0/126.d0,&
    -783917.d0/1568.d0,775337.d0/1512.d0,-30533.d0/72.d0,745307.d0/2640.d0,-715277.d0/4752.d0,&
    655217.d0/10296.d0,-475037.d0/24024.d0,35236393.d0/12612600.d0,1195757.d0/2882880.d0&
    /)
!In[91]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->-8}]]]]
!Out[91]//FortranForm=
    c2D(-m:m,-8) = (/&
    993366559.d0/100900800.d0,-3431678.d0/45045.d0,2076199.d0/6006.d0,-4392638.d0/3861.d0,&
    2256379.d0/792.d0,-916966.d0/165.d0,2316439.d0/270.d0,-4667198.d0/441.d0,&
    2346469.d0/224.d0,-174554.d0/21.d0,2364487.d0/450.d0,-431098.d0/165.d0,2376499.d0/2376.d0,&
    -366326.d0/1287.d0,2385079.d0/42042.d0,-4777022.d0/675675.d0,1195757.d0/2882880.d0&
    /)
!In[92]:= ff=FortranForm[Expand[Simplify[ReplaceAll[D[f[x],x],{x->+8}]]]]
!Out[92]//FortranForm=
    c2D(-m:m,8) = (/&
    1195757.d0/2882880.d0,-4777022.d0/675675.d0,2385079.d0/42042.d0,-366326.d0/1287.d0,&
    2376499.d0/2376.d0,-431098.d0/165.d0,2364487.d0/450.d0,-174554.d0/21.d0,&
    2346469.d0/224.d0,-4667198.d0/441.d0,2316439.d0/270.d0,-916966.d0/165.d0,2256379.d0/792.d0,&
    -4392638.d0/3861.d0,2076199.d0/6006.d0,-3431678.d0/45045.d0,993366559.d0/100900800.d0&
    /)

   end select
